function wpwhoosh_host_confirm_delete(id) {
  return confirm("You are about to delete the host with ID "+id+"\n Press `Cancel` to stop, `OK` to delete." );
}

function wpwhoosh_add_pin(pin, updated) {
	var secret = '';
	var oldsecret = '';
	if ((pin==null) || (pin=='')) return false;
	var ts = Math.round((new Date()).getTime() / 1000).toString();
	var p = CryptoJS.MD5(pin);
	if (p)  { 
		secret = CryptoJS.MD5(p.toString()+ts);
		if (updated > 0) oldsecret = CryptoJS.MD5(p.toString()+updated);
	}
	if (secret.toString().length > 0) {
        jQuery('#pin').val(''); //clear the PIN as we do not want to send it in free text	
		jQuery('form#host_form').append(
			'<input type="hidden" name="time" value="'+ts+'"/><input type="hidden" name="hash" value="'+secret.toString()+'"/><input type="hidden" name="hash2" value="'+oldsecret.toString()+'"/>');
			return true;
	} else {
			return false;
	}
}

function wpwhoosh_check_pin(updated) {
	var spin = jQuery('#pin').val();
	return spin ? wpwhoosh_add_pin(spin, updated) : wpwhoosh_open_dialog(); 
}

function wpwhoosh_open_dialog() {
	jQuery( "#dialog-form" ).dialog( "open" );
	return false;
}

function wpwhoosh_define_dialog() {
    jQuery( "#dialog-form" ).dialog({
		autoOpen: false,
		height: 200,
		width: 350,
		resize: false,
		modal: true,
		buttons: { 
		"Ok": function() {
			var bValid = true;
			var yourpin = jQuery('#yourpin');
			bValid = bValid && wpwhoosh_check_length( yourpin, "PIN field", 4, 8 ); 
			bValid = bValid && wpwhoosh_check_regex( yourpin, /^([0-9])+$/, "PIN field only allows digits : 0-9" );
			if ( bValid ) {
          		jQuery('#pin').val(yourpin.val()); //move valid PIN to hidden field in main form
          		jQuery('#host_form').submit(); //submit form
          		jQuery( this ).dialog( "close" );
			}

        },
    	"Cancel" : function() { jQuery( this ).dialog( "close" ); } 
      },    
      close: function() { jQuery('#yourpin').val('').removeClass('ui-state-error'); },
      dialogClass: 'wp-dialog'
	});
}
 
function wpwhoosh_update_tips( t ) {
      jQuery("#validateTips").text(t).addClass( "ui-state-highlight" );
      setTimeout(function() {
        jQuery("#validateTips").removeClass( "ui-state-highlight", 1500 );
      }, 500 );
}
 
function wpwhoosh_check_length( o, n, min, max ) {
	if ( o.val().length > max || o.val().length < min ) {
        o.addClass( "ui-state-error" );
        wpwhoosh_update_tips( "Length of " + n + " must be between " + min + " and " + max + "." );
        return false;
    } else {
        return true;
    }
}
 
function wpwhoosh_check_regex( o, regexp, n ) {
	if ( !( regexp.test( o.val() ) ) ) {
        o.addClass( "ui-state-error" );
        wpwhoosh_update_tips( n );
        return false;
	} else {
        return true;
	}
}
 
function wpwhoosh_is_save() {
	action = jQuery('input[name=action]').val(); //get action   
	return "save"===action;
}

function wpwhoosh_user_length() {
	return wpwhoosh_is_save() ? 8 : 32;
}

function wpwhoosh_host_validator() {
    jQuery('#save').unbind('click'); 
	
	if ( wpwhoosh_is_save()) {
    jQuery('#host_form').validate({
      ignore: ":submit",
      rules: {
        host_name: { required: true },
        cpanel_url: { required: true, url: true },
        cpanel_user: { required: true, alphanumeric: true, minlength : 2, maxlength: 8 },
        cpanel_password: { required: true },
		},
      messages: {
        host_name: { required: "Enter a short meaningful name for your host" },
        cpanel_url: { required: "Enter your full cPanel URL including the port number",
        		url : "cPanel should be of the format https://gator1234.hostgator.com:2083" },
        cpanel_user: { 
        	required: "Enter your cPanel user name",
        	alphanumeric: "The username should consist of just numbers and letters"
        	},
        cpanel_password: { required:  "Enter your cPanel password" },
      },
      submitHandler: function(form) {
      	updated = jQuery('input[name=updated]').val(); //get updated
      	action = jQuery('input[name=action]').val(); //get action
      	haspin = jQuery('input[name=haspin]').val(); //is pin required?
		if ((('save'==action) || 'update'==action) && (1==haspin) && !wpwhoosh_check_pin(updated)) return false;
        jQuery('#save').attr("disabled", "disabled"); //stop extra clicks
        form.submit();
      },       
    });
    } else {		
    jQuery('#host_form').validate({
      ignore: ":submit",
      rules: {
        host_name: { required: true },
        cpanel_url: { required: true },
        cpanel_user: { required: true, minlength : 2, maxlength: 32 },
        cpanel_password: { required: true },
		},
      messages: {
        host_name: { required: "Enter a short meaningful name for your host" },
        cpanel_url: { required: "Enter your full cPanel URL including the port number"},
        cpanel_user: { required: "Enter your cPanel user name" },
        cpanel_password: { required:  "Enter your cPanel password" },
      },
      submitHandler: function(form) {
      	updated = jQuery('input[name=updated]').val(); //get updated
      	action = jQuery('input[name=action]').val(); //get action
      	haspin = jQuery('input[name=haspin]').val(); //is pin required?
		if ((('save'==action) || 'update'==action) && (1==haspin) && !wpwhoosh_check_pin(updated)) return false;
        jQuery('#save').attr("disabled", "disabled"); //stop extra clicks
        form.submit();
      },       
    });
    }
}

jQuery(document).ready(function() {
	wpwhoosh_define_dialog();
	wpwhoosh_host_validator();
});